<app-base-layout [enableMobileHeader]="true" title="Orders" [enableDeskTopHeader] ="true" [enableDeskTopHeaderAction]="true" >
  <div class="container d-none d-lg-block">
    <!-- desktop view -->
    <div class="order-wrapper">
      <div class="row">
        <div class="col-12 col-lg-6">
          <div class="header">
            <span>Executed</span>
          </div>
          <div
            class="card"
            routerLink="{{ '/explore/stocks/' + data.companyId }}"
            *ngFor="let data of orderListData"
          >
            <div class="card-body">
              <div class="row">
                <div class="col-auto col-lg-2 pr-0">
                  <span
                    [ngClass]="
                      data.tradeAction == 'SELL'
                        ? 'selling-status'
                        : 'buying-status'
                    "
                    >{{ data.tradeAction }}</span
                  >
                </div>
                <div class="col col-lg-3 pl-lg-0" style="white-space: nowrap;">
                  Qty : {{ data.executeQuantity }} / {{ data.quantity }}
                </div>
                <div class="col text-right">
                  <span *ngIf="data.status == 1" class="status completed"
                    >completed</span
                  >
                  <span
                    *ngIf="data.status == 2"
                    class="status partially-executed"
                    >Partially-Executed</span
                  >
                  <span *ngIf="data.status == 3" class="status rejected"
                    >Rejected</span
                  >
                  <span *ngIf="data.status == 4" class="status canceled"
                    >Canceled</span
                  >
                </div>
              </div>
              <div class="card-title">{{ data.name }}</div>
              <div class="row">
                <div class="col">
                  <div class="title">${{ data.buyPrice }}</div>
                  <div class="text">
                    {{ data.tradeAction | titlecase }} Price
                  </div>
                </div>
                <div class="col">
                  <div class="text">
                    <strong>{{ data.orderType }}</strong>
                  </div>
                </div>
                <div class="col">
                  <div class="text">
                    <strong>{{ data.updatedAt | date: "dd/MMM/yyyy" }}</strong>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
        <div class="col-12 col-lg-6">
          <div class="header">
            <span>Pending</span>
          </div>
          <div
            class="card"
            (click)="cancelOrderDetail($event, data, cancleOrderDetail)"
            *ngFor="let data of pendingOrderListData"
          >
            <div class="card-body">
              <div class="row">
                <div class="col-auto col-lg-2 pr-0">
                  <span
                    [ngClass]="
                      data.tradeAction == 'SELL'
                        ? 'selling-status'
                        : 'buying-status'
                    "
                    >{{ data.tradeAction }}</span
                  >
                </div>
                <div class="col col-lg-3 pl-lg-0" style="white-space: nowrap;">
                  Qty : {{ data.executeQuantity }} / {{ data.quantity }}
                </div>

                <div class="col text-right">
                  <span class="status pending">pending</span>
                </div>
              </div>
              <div class="card-title">{{ data.name }}</div>
              <div class="row">
                <div class="col" *ngIf="data.orderType != 'Market'">
                  <ng-container>
                    <div class="title">${{ data.buyPrice }}</div>
                    <div class="text">
                      {{ data.tradeAction | titlecase }} Price
                    </div>
                  </ng-container>
                </div>
                <div class="col">
                  <div class="title">${{ data.price }}</div>
                  <div class="text">Current Price</div>
                </div>
                <div class="col">
                  <div class="text">
                    <strong>{{ data.orderType }}</strong>
                  </div>
                </div>
                <div class="col">
                  <div class="text">
                    <strong>{{ data.updatedAt | date: "dd/MMM/yyyy" }}</strong>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
      <!-- mobile -->
    </div>
    <!-- desktop view end-->
  </div>
  <!-- mobile view -->
  <div class="d-block d-lg-none">
    <app-nav-tabs
      [tabs]="orderTabs"
      (onClick)="handleOnClick($event)"
    ></app-nav-tabs>
    <div class="container-fluid order-wrapper">
      <div class="row">
        <div class="col-12 mt-3" *ngIf="activeFinancialTab === 'Executed'">
          <div
            class="card"
            routerLink="{{ '/explore/stocks/' + data.companyId }}"
            *ngFor="let data of orderListData"
          >
            <div class="card-body">
              <div class="row">
                <div class="col-auto col-lg-2 pr-0">
                  <span
                    [ngClass]="
                      data.tradeAction == 'SELL'
                        ? 'selling-status'
                        : 'buying-status'
                    "
                    >{{ data.tradeAction }}</span
                  >
                </div>
                <div class="col col-lg-3 pl-lg-0">
                  Qty : {{ data.executeQuantity }} / {{ data.quantity }}
                </div>
                <div class="col text-right">
                  <span *ngIf="data.status == 1" class="status completed"
                    >completed</span
                  >
                  <span
                    *ngIf="data.status == 2"
                    class="status partially-executed"
                    >Partially-Executed</span
                  >
                  <span *ngIf="data.status == 3" class="status rejected"
                    >Rejected</span
                  >
                  <span *ngIf="data.status == 4" class="status canceled"
                    >Canceled</span
                  >
                </div>
              </div>
              <div class="card-title">{{ data.name }}</div>
              <div class="row">
                <div class="col">
                  <div class="title">${{ data.buyPrice }}</div>
                  <div class="text">
                    {{ data.tradeAction | titlecase }} Price
                  </div>
                </div>
                <!-- <div class="col">
                  <div class="title">${{data.price}}</div>
                  <div class="text">Current Price</div>
                </div> -->
                <div class="col">
                  <div class="text">
                    <strong>{{ data.orderType }}</strong>
                  </div>
                </div>
                <div class="col">
                  <div class="text">
                    <strong>{{ data.updatedAt | date: "dd/MMM/yyyy" }}</strong>
                  </div>
                </div>
                <!-- <div class="col-4">
                  <div class="title">$200 (+2%)</div>
                  <div class="text">Profit</div>
                </div> -->
              </div>
            </div>
          </div>
        </div>
        <div class="col-12 mt-3" *ngIf="activeFinancialTab === 'Pending'">
          <div
            class="card"
            (click)="cancelOrderDetail($event, data, cancleOrderDetail)"
            *ngFor="let data of pendingOrderListData"
          >
            <div class="card-body">
              <div class="row">
                <div class="col-auto col-lg-2 pr-0">
                  <span
                    [ngClass]="
                      data.tradeAction == 'SELL'
                        ? 'selling-status'
                        : 'buying-status'
                    "
                    >{{ data.tradeAction }}</span
                  >
                </div>
                <div class="col col-lg-3 pl-lg-0">
                  Qty : {{ data.executeQuantity }} / {{ data.quantity }}
                </div>

                <div class="col text-right">
                  <span class="status pending">pending</span>
                </div>
              </div>
              <div class="card-title">{{ data.name }}</div>
              <div class="row">
                <div class="col" *ngIf="data.orderType != 'Market'">
                  <ng-container>
                    <div class="title">${{ data.buyPrice }}</div>
                    <div class="text">
                      {{ data.tradeAction | titlecase }} Price
                    </div>
                  </ng-container>
                </div>
                <div class="col">
                  <div class="title">${{ data.price }}</div>
                  <div class="text">Current Price</div>
                </div>
                <div class="col">
                  <div class="text">
                    <strong>{{ data.orderType }}</strong>
                  </div>
                </div>
                <div class="col">
                  <div class="text">
                    <strong>{{ data.updatedAt | date: "dd/MMM/yyyy" }}</strong>
                  </div>
                </div>
                <!-- <div class="col">
                  <div class="title">${{data.price * data.quantity | number: "1.2-2"}}</div>
                  <div class="text">Est Price</div>
                </div> -->
                <!-- <div class="col-4 text-right">
                  <button class="btn custombtn btn-danger" (click)="cancelOrderDeail($event, data , cancleOrderDetail)">Cancel</button>
                </div> -->
                <!-- <div class="col-4">
                  <div class="title">$200 (+2%)</div>
                  <div class="text">Profit</div>
                </div> -->
              </div>
            </div>
          </div>
        </div>
      </div>
      <!-- mobile -->
    </div>
  </div>
  <!-- mobile view end -->

  <!-- load more -->
  <div class="container">
    <div class="mobile-btn-common card" *ngIf="!loading && showLoadBtn">
      <button class="btn" (click)="loadMore()">Load more</button>
    </div>
    <div *ngIf="loading" class="text-center">loading...</div>
  </div>
  <!-- load more end -->

  <!-- cancle order detail modal -->
  <ng-template #cancleOrderDetail let-c="close" let-d="dismiss">
    <div class="cancle-order-detail-modal">
      <div class="modal-header">
        <h4 class="modal-title" id="modal-basic-title">
          {{ setectedOrder.name }}
        </h4>
        <button
          type="button"
          class="close"
          aria-label="Close"
          (click)="d('Cross click')"
        >
          <span aria-hidden="true">&times;</span>
        </button>
      </div>
      <div class="modal-body">
        <div class="content">
          <div class="status">
            <span class="pending">pending</span>
            <span class="sell">{{ setectedOrder.tradeAction }}</span>
          </div>
          <div class="d-flex justify-content-between">
            <div class="text">
              Avg Buy Price : <strong>${{ setectedOrder.buyPrice }}</strong>
            </div>
            <div class="text">
              Units : <strong>{{ setectedOrder.quantity }}</strong>
            </div>
          </div>
          <div class="d-flex justify-content-between my-3">
            <div class="text">
              <strong>{{ setectedOrder.orderType }} Order</strong>
            </div>
          </div>
        </div>
      </div>
      <div class="modal-footer">
        <div class="col p-0">
          <button
            class="btn btn-cancel"
            (click)="cancleOrderModal(cancleOrders)"
          >
            Cancel
          </button>
        </div>
        <div class="col p-0">
          <button
            class="btn btn-modify"
            (click)="
              openBuyStocksModal(
                BuyStocksModal,
                setectedOrder.tradeAction,
                setectedOrder.companyId,
                setectedOrder.orderId
              )
            "
          >
            Modify
          </button>
        </div>
      </div>
    </div>
  </ng-template>
  <!-- cancle order detail modal end -->

  <!-- cancle order modal -->
  <ng-template #cancleOrders let-c="close" let-d="dismiss">
    <div class="cancle-order-modal">
      <div class="modal-header">
        <h4 class="modal-title" id="modal-basic-title">Cancel Order?</h4>
        <button
          type="button"
          class="close"
          aria-label="Close"
          (click)="d('Cross click')"
        >
          <span aria-hidden="true">&times;</span>
        </button>
      </div>
      <div class="modal-body">
        <div class="text">
          Are you sure you want to cancel
          {{ setectedOrder.tradeAction }} request of
          <strong>{{ setectedOrder.quantity }} {{ setectedOrder.name }}</strong>
          stocks for <strong>${{ setectedOrder.buyPrice }}</strong>
        </div>
      </div>
      <div class="modal-footer">
        <button
          type="button"
          class="btn btn-outline-dark"
          (click)="cancleOrder()"
        >
          Cancel request
        </button>
      </div>
    </div>
  </ng-template>
  <!-- cancle order modal end-->

  <!-- buy stock modal -->
  <ng-template #BuyStocksModal let-c="close" let-d="dismiss">
    <form
      [formGroup]="updateOrderForm"
      (ngSubmit)="onOrderFormSubmit()"
      *ngIf="stockPreOrderDetail"
    >
      <div class="BuyStocksmodal">
        <div class="modal-header">
          <div class="header">
            <h4 class="modal-title pb-1" id="modal-basic-title">
              {{ stockPreOrderDetail.name }}
            </h4>
            <span>${{ stockPreOrderDetail.price | number: "1.2-2" }}</span
            ><span
              class="px-3 clr"
              [ngClass]="{
                'gain-color': stockPreOrderDetail.priceDiff > 0,
                'loss-color': stockPreOrderDetail.priceDiff < 0
              }"
              >{{
                stockPreOrderDetail.priceDiff | number: "1.2-2" | signCurrency
              }}</span
            ><span
              class="clr"
              [ngClass]="{
                'gain-color': stockPreOrderDetail.priceDiffPercentage > 0,
                'loss-color': stockPreOrderDetail.priceDiffPercentage < 0
              }"
            >
              {{
                stockPreOrderDetail.priceDiffPercentage | number: "1.2-2"
              }}%</span
            >
          </div>
          <button
            type="button"
            class="close"
            aria-label="Close"
            (click)="d('Cross click')"
          >
            <span aria-hidden="true">&times;</span>
          </button>
        </div>
        <div class="modal-body overflow-auto">
          <div class="form-group mr-3 pt-3">
            <input
              type="number"
              class="form-control"
              formControlName="quantity"
              [(ngModel)]="orderDetail.quantity"
              placeholder="Quantity"
            />
          </div>

          <div class="row">
            <div class="col-6">
              <div class="form-group mr-3 pt-3">
                <select
                  class="form-control"
                  name="orderType"
                  formControlName="orderType"
                  [(ngModel)]="orderDetail.orderType"
                >
                  <option
                    *ngFor="let orderType of stockPreOrderDetail.orderType"
                    [value]="orderType"
                  >
                    {{ orderType }}
                  </option>
                </select>
              </div>
            </div>
            <div class="col-6">
              <div class="from-group pt-3">
                <div class="input-group">
                  <input
                    type="number"
                    class="form-control"
                    formControlName="price"
                    placeholder="0"
                    [(ngModel)]="orderDetail.price"
                  />
                  <div class="input-group-append">
                    <span class="input-group-text">$</span>
                  </div>
                </div>
                <div class="separator" style="width: 100%; height: 26px"></div>
              </div>
            </div>
            <div class="col-6" *ngIf="stopPriceSection">
              <div class="from-group pt-3">
                <div class="input-group">
                  <input
                    type="number"
                    class="form-control"
                    formControlName="stopPrice"
                    placeholder="stop Price"
                    [(ngModel)]="orderDetail.stopPrice"
                  />
                  <div class="input-group-append">
                    <span class="input-group-text">$</span>
                  </div>
                </div>
                <div class="separator" style="width: 100%; height: 26px"></div>
              </div>
            </div>
          </div>
          <!-- <div class="from-group pt-3">
              <div class="input-group">
                <input type="number" class="form-control" formControlName="stopPrice" placeholder="stop Price" />
                <div class="input-group-append">
                  <span class="input-group-text">$</span>
                </div>
              </div>
              <div class="separator" style="width: 100%; height: 26px"></div>
            </div> -->
          <!--   
            <div class="advanceOption" *ngIf="advanceOptionText" (click)="advanceOption()">Advanced Option</div>
            <div *ngIf="advanceOptionField">
              <div class="row">
                <div class="col-6">
                  <div class="form-group pt-3">
                    <select class="form-control" style="width: 100%;" name="duration" [disabled]="true">
                      <option *ngFor="let duration of stockPreOrderDetail.duration" [value]="duration">{{duration}}
                      </option>
                    </select>
                  </div>
                </div>
              </div>
            </div> -->
          <div class="content">
            <div class="row mt-3">
              <div class="col-6">
                <div class="pr-1 value gain-color">
                  ${{ stockPreOrderDetail.accountBalance }}
                </div>
                <div class="title">Cash Available</div>
              </div>
            </div>
            <div class="d-flex justify-content-between mt-4">
              <div class="mr-3">Qty: {{ stockPreOrderDetail.quantity }}</div>
              <div>
                Buy Price:
                <div
                  class="d-inline market-status mr-3"
                  [ngClass]="{
                    'gain-color': stockPreOrderDetail.avgPrice > 0,
                    'loss-color': stockPreOrderDetail.avgPrice < 0
                  }"
                >
                  {{
                    stockPreOrderDetail.avgPrice
                      | number: "1.2-2"
                      | signCurrency
                  }}
                </div>
              </div>
            </div>
          </div>
          <!-- <div class="form-group mr-3 pt-3">
              <select class="form-control input" style="width: 100px;" name="duration"  formControlName="duration" >
                <option *ngFor="let duration of stockPreOrderDetail.duration" [value]="duration" >{{duration}}</option>
              </select>
            </div> -->
        </div>
        <div class="modal-footer">
          <!-- <div class="content">
              <div class="d-flex">
                <div class="mr-3">Qty: {{stockPreOrderDetail.quantity}}</div>
                <div>Buy Price: <div class="d-inline market-status mr-3" [ngClass]="{'gain-color': stockPreOrderDetail.avgPrice > 0 , 'loss-color':stockPreOrderDetail.avgPrice < 0  }" >{{stockPreOrderDetail.avgPrice | number : '1.2-2' | signCurrency}}</div></div>
              </div>
              <div>
                <h5 class="pr-1">${{stockPreOrderDetail.accountBalance}}</h5>
                <span>Wallet Amount</span>
              </div>
            </div> -->
          <button
            type="submit"
            class="btn"
            [ngClass]="{
              'btn-green': tradeAction === 'BUY',
              'btn-red': tradeAction === 'SELL'
            }"
          >
            {{ tradeAction }}
          </button>
          <button
            type="button"
            class="btn btn-terms"
            (click)="openTermsModal(termsModal)"
          >
            <img src="assets/icons/info-icon.svg" class="mr-2" />Term
            Definitions
          </button>
        </div>
      </div>
    </form>
  </ng-template>
  <!-- buy stock modal end-->

  <!-- confermation modal -->
  <ng-template #confermModal let-c="close" let-d="dismiss">
    <div class="conferm-modal">
      <div class="modal-header">
        <h4 class="modal-title" id="modal-basic-title">Term Definitions</h4>
        <button
          type="button"
          class="close"
          aria-label="Close"
          (click)="d('Cross click')"
        >
          <span aria-hidden="true">&times;</span>
        </button>
      </div>
      <div class="modal-body"></div>
    </div>
  </ng-template>
  <!-- confermation modal end -->

  <!-- terms and condition modal -->
  <ng-template #termsModal let-c="close" let-d="dismiss">
    <div class="terms-defination-modal">
      <div class="modal-header">
        <h4 class="modal-title" id="modal-basic-title">
          <img src="assets/icons/info-icon.svg" class="mr-2" />Term Definitions
        </h4>
        <button
          type="button"
          class="close"
          aria-label="Close"
          (click)="d('Cross click')"
        >
          <span aria-hidden="true">&times;</span>
        </button>
      </div>
      <div class="modal-body">
        <div *ngFor="let termsDefination of termsDefinationData">
          <div class="heading">{{ termsDefination.heading }}</div>
          <div class="text">{{ termsDefination.text }}</div>
        </div>
      </div>
    </div>
  </ng-template>
  <!-- terms and condition modal end-->
</app-base-layout>
